unit umain;

{$mode objfpc}{$H+}
{$DEFINE AFIP_PRODUCCION}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation
uses
  OpenSSL, cTypes, DateUtils;

function DateTimeToISO(aValor: tDateTime): string;
var
  sDate, sTime: string;
  NewValor: tDateTime;
  iMinutos: integer;
begin
  iMinutos := GetLocalTimeOffset;
  if (iMinutos / 60 < -12) and (iMinutos / 60 > 12) then
    raise Exception.Create('No se puede determinar huso horario');
  NewValor := LocalTimeToUniversal(aValor, iMinutos * -1);
  sDate := FormatDateTime('yyyy-mm-dd', NewValor);
  sTime := FormatDateTime('hh:nn:ss.zzz', NewValor);
  Result := sDate + 'T' + sTime + 'Z';
end;

function _GenerarLoginTicketRequest(Source, destination, uniqueid,
  generationtime, expirationtime: string): string;
begin
  Result :=
    '<?xml version="1.0" encoding="UTF­8"?>' + LineEnding +
    '<loginTicketRequest version="1.0">' + LineEnding + '<header>' +
    LineEnding + '  <source>' + Source + '</source>' + LineEnding +
    '  <destination>' + destination + '</destination>' + LineEnding +
    '  <uniqueId>' + uniqueid + '</uniqueId>' + LineEnding +
    '  <generationTime>' + generationtime + '</generationTime>' +
    LineEnding + '  <expirationTime>' + expirationtime + '</expirationTime>' +
    LineEnding + '</header>' + LineEnding + '<service>wsfe</service>' +
    LineEnding + '</loginTicketRequest>';
end;

function _FirmarLoginTicketRequest(cuit, nombre, key, cert: string): string;
var
  s: TStringList;
  cn: string;
  cbuf: string;
  kbuf: string;
  pXml: string;
  bioc, biok, biom, bios: PBIO;
  fc: PX509;
  fk: PEVP_PKEY;
  smsg: PPKCS7;
  buf: string;
  nlen: cInt;
begin
  Result := '';

  {$IFDEF AFIP_PRODUCCION}
    cn := 'wsaa';
  {$ELSE}
    cn := 'wsaahomo';
  {$ENDIF}

  s := TStringList.Create;
  try
    // REQUEST XML
    s.Text := _GenerarLoginTicketRequest('SERIALNUMBER=CUIT ' + cuit +
      ', CN=' + nombre, 'CN=' + cn + ', O=AFIP, C=AR, SERIALNUMBER=CUIT 33693450239',
      '4325399', DateTimeToISO(now), DateTimeToISO(inchour(now, 12)));

    pXml := s.Text;

    s.LoadFromFile(cert);
    cbuf := s.Text;

    s.LoadFromFile(key);
    kbuf := s.Text;

    bioc := BIO_new_mem_buf(@cbuf, Length(cbuf));

    fc := PEM_read_bio_X509(bioc, nil, nil, nil);

    biok := BIO_new_mem_buf(@kbuf, Length(kbuf));

    fk := PEM_read_bio_PrivateKey(biok, nil, nil, nil);

    biom := BIO_new_mem_buf(@pXml, Length(pXml));

    smsg := PKCS7_sign(fc, fk, nil, @biom, 0);

    bios := BioNew(BioSMem);

    PEM_write_bio_PKCS7(bios, smsg);

    SetLength(buf, 4096);

    nlen := BIORead(bios, buf, Length(buf));

    s.Text := Copy(buf, 0, nlen);

    // delete BEGIN PKCS7 -- END PKCS7
    s.Delete(0);
    s.Delete(s.Count - 1);
    Result := s.Text;
  finally
    s.Free;
  end;
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Text := _FirmarLoginTicketRequest('20349224039', 'Leandro Diaz', Application.Location + 'leandro.key', Application.Location + 'leandro.crt');
end;

end.

